"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("../polyfills/tslib.js");
var rl_web_components_core_js_1 = require("../rl-web-components.core.js");
var Coordinate = function () { function t(t, e) { this.x = t, this.y = e; } return t.prototype.clone = function () { return new t(this.x, this.y); }, t.prototype.toString = function () { return "(" + this.x + ", " + this.y + ")"; }, t.prototype.toPathString = function () { return this.x + " " + this.y; }, t.prototype.equals = function (e) { return e instanceof t && t.equals(this, e); }, t.prototype.ceil = function () { return this.x = Math.ceil(this.x), this.y = Math.ceil(this.y), this; }, t.prototype.floor = function () { return this.x = Math.floor(this.x), this.y = Math.floor(this.y), this; }, t.prototype.translate = function (e, i) { return e instanceof t ? (this.x += e.x, this.y += e.y) : (this.x += Number(e), "number" == typeof i && (this.y += i)), this; }, t.prototype.scale = function (t, e) { return e = "number" == typeof e ? e : t, this.x *= t, this.y *= e, this; }, t.prototype.rotateRadians = function (e, i) { i = i || new t(0, 0); var n = this.x, o = this.y, r = Math.cos(e), a = Math.sin(e); return this.x = (n - i.x) * r - (o - i.y) * a + i.x, this.y = (n - i.x) * a + (o - i.y) * r + i.y, this; }, t.prototype.rotateDegrees = function (t, e) { return this.rotateRadians(t * Math.PI / 180, e); }, t.prototype.limit = function (t) { if (!t)
    throw new Error("Unable to limit Corrdinate, limits undefined!"); var e = isNaN(t.left) ? void 0 : t.left, i = isNaN(t.width) ? 0 : t.width; this.x = Math.min(void 0 !== e ? e + i : 1 / 0, Math.max(void 0 !== e ? e : -1 / 0, this.x)); var n = isNaN(t.top) ? void 0 : t.top, o = isNaN(t.height) ? 0 : t.height; return this.y = Math.min(void 0 !== n ? n + o : 1 / 0, Math.max(void 0 !== n ? n : -1 / 0, this.y)), this; }, t.prototype.round = function (t) { void 0 === t && (t = 0); var e = Math.pow(10, t); return this.x = Math.round(this.x * e) / e, this.y = Math.round(this.y * e) / e, this; }, t.equals = function (t, e) { return t === e || t.x === e.x && t.y === e.y; }, t.distance = function (t, e) { var i = t.x - e.x, n = t.y - e.y; return Math.sqrt(i * i + n * n); }, t.magnitude = function (t) { return Math.sqrt(t.x * t.x + t.y * t.y); }, t.squareDistance = function (t, e) { var i = t.x - e.x, n = t.y - e.y; return i * i + n * n; }, t.difference = function (e, i) { return i ? new t(e.x - i.x, e.y - i.y) : new t(0, 0); }, t.sum = function (e, i) { return new t(e.x + i.x, e.y + i.y); }, t.midpoint = function (e, i) { return new t((e.x + i.x) / 2, (e.y + i.y) / 2); }, t; }();
exports.b = Coordinate;
function getClientPosition(t) { if (1 === t.nodeType)
    return getClientPositionForElement_(t); var e = t.changedTouches ? t.changedTouches[0] : t; return new Coordinate(e.clientX, e.clientY); }
function getClientPositionForElement_(t) { var e = getBoundingClientRect_(t); return new Coordinate(e.left, e.top); }
function getBoundingClientRect_(t) { var e; try {
    e = t.getBoundingClientRect();
}
catch (t) {
    return { left: 0, top: 0, right: 0, bottom: 0 };
} return e; }
function coordinateFromEvent(t, e) { var i = getClientPosition(t), n = getClientPosition(e); return new Coordinate(i.x - n.x, i.y - n.y); }
exports.f = coordinateFromEvent;
function decodeCoordinates(t, e) { for (var i, n, o = t.split(" "), r = [], a = o.length - 2, s = e ? "Z" : ""; a >= 0;)
    i = Math.round(Number(o[a])), n = Math.round(Number(o[a + 1])), r.push(new Coordinate(i, n)), s = 0 === a ? ["M", i, n, s].join(" ") : ["L", i, n, s].join(" "), a -= 2; return 1 === r.length && (r = r[0]), { path: s, points: r }; }
function encodeCoordinates(t) { return t instanceof Coordinate ? t.toPathString() : t.map(function (t) { return t.toPathString(); }).join(" "); }
exports.l = encodeCoordinates;
function pathFromCoordinateArray(t, e) { return void 0 === e && (e = !1), t.map(function (i, n) { return 0 === n ? "M " + i.toPathString() : n !== t.length - 1 || e ? " L " + i.toPathString() : " L " + i.toPathString() + " Z"; }).join(""); }
var MarkerSymbolPaths, MapElement = function () { function t(t) { this._active = !1, this._clickable = !0, this._id = -1, this._name = "", this._scale = 1, this._visible = !0, this._zIndex = 1, t && (this.name = void 0 !== t.name ? t.name : "", this.zIndex = void 0 !== t.zIndex ? t.zIndex : 1); } return Object.defineProperty(t.prototype, "active", { get: function () { return this._active; }, set: function (t) { this._active = t; }, enumerable: !0, configurable: !0 }), Object.defineProperty(t.prototype, "clickable", { get: function () { return this._clickable; }, set: function (t) { this._clickable = t; }, enumerable: !0, configurable: !0 }), Object.defineProperty(t.prototype, "id", { get: function () { return this._id; }, set: function (t) { this._id = t; }, enumerable: !0, configurable: !0 }), Object.defineProperty(t.prototype, "name", { get: function () { return this._name; }, set: function (t) { this._name = t; }, enumerable: !0, configurable: !0 }), Object.defineProperty(t.prototype, "scale", { get: function () { return this._scale; }, set: function (t) { this._scale = t; }, enumerable: !0, configurable: !0 }), Object.defineProperty(t.prototype, "visible", { get: function () { return this._visible; }, set: function (t) { this._visible = t; }, enumerable: !0, configurable: !0 }), Object.defineProperty(t.prototype, "zIndex", { get: function () { return this._zIndex; }, set: function (t) { this._zIndex = t; }, enumerable: !0, configurable: !0 }), t; }(), CONTROL_SIZE = 50, MapMarker = function (t) { function e(e) { var i = t.call(this, e) || this; return i._anchor = new Coordinate(0, 0), i._available = !1, i._label = "", i._opacity = 1, i._position = new Coordinate(0, 0), e && (i.anchor = e.anchor ? e.anchor : new Coordinate(0, 0), i.available = !!e.available && e.available, i.icon = e.icon ? e.icon : void 0, i.label = void 0 !== e.label ? e.label : "", i.opacity = void 0 !== e.opacity ? e.opacity : 1, i.position = e.position), i; } return tslib_1.__extends(e, t), Object.defineProperty(e.prototype, "anchor", { get: function () { return this._anchor; }, set: function (t) { this._anchor = t; }, enumerable: !0, configurable: !0 }), Object.defineProperty(e.prototype, "available", { get: function () { return this._available; }, set: function (t) { this._available = t; }, enumerable: !0, configurable: !0 }), Object.defineProperty(e.prototype, "icon", { get: function () { return this._icon; }, set: function (t) { this._icon = t; }, enumerable: !0, configurable: !0 }), Object.defineProperty(e.prototype, "label", { get: function () { return this._label; }, set: function (t) { this._label = t; }, enumerable: !0, configurable: !0 }), Object.defineProperty(e.prototype, "opacity", { get: function () { return this._opacity; }, set: function (t) { this._opacity = Math.max(0, Math.min(1, t)); }, enumerable: !0, configurable: !0 }), Object.defineProperty(e.prototype, "position", { get: function () { return this._position; }, set: function (t) { this._position = t; }, enumerable: !0, configurable: !0 }), e.prototype.move = function (t) { this._position.translate(t); }, e.prototype.render = function () { if (this.visible) {
    var t = [], e = rl_web_components_core_js_1.h("rect", { class: { "rl-map-rect": !0, "rl-map-rect--activated": this.active }, rx: "12", ry: "12", height: CONTROL_SIZE, width: CONTROL_SIZE });
    void 0 === this._icon ? t.push(e) : (this._icon.size = { width: CONTROL_SIZE, height: CONTROL_SIZE }, t.push(this._icon.render()), t.push(e));
    var i = "translate(" + this.position.toPathString() + ")";
    return rl_web_components_core_js_1.h("g", { id: this._id, class: { "rl-map-marker": !0, "rl-map-marker--clickable": this._clickable, "rl-map-marker--available": this._available }, tabindex: this._clickable ? "0" : void 0, transform: i }, t);
} }, e; }(MapElement), MapPolygon = function (t) { function e() { var e = t.apply(this, arguments) || this; return e._open = !1, e._path = "", e._points = [], e; } return tslib_1.__extends(e, t), Object.defineProperty(e.prototype, "open", { get: function () { return this._open; }, set: function (t) { this._open = t, this._path = pathFromCoordinateArray(this._points, t); }, enumerable: !0, configurable: !0 }), Object.defineProperty(e.prototype, "points", { get: function () { return this._points; }, set: function (t) { this._points = t, this._path = pathFromCoordinateArray(t, this._open); }, enumerable: !0, configurable: !0 }), e.prototype.addPoint = function (t, e) { var i = this._points; this.points = void 0 !== e ? i.slice(0, e).concat([t], i.slice(e)) : i.concat([t]); }, e.prototype.move = function (t) { var e = this.points; e.forEach(function (e) { return e.translate(t); }), this.points = e.slice(); }, e.prototype.movePoint = function (t, e) { var i = this.points; i[e].translate(t), this.points = i.slice(); }, e.prototype.removePoint = function (t) { var e = this._points; e.splice(void 0 !== t ? t : e.length - 1, 1), this.points = e.slice(); }, e.prototype.render = function () { if (!1 !== this._visible)
    return rl_web_components_core_js_1.h("path", { id: this._id, class: { "rl-map-polygon": !0, "rl-map-polygon--activated": this._active }, d: this._path, tabindex: "0", "aria-label": this._name, role: "button" }); }, e.prototype.renderControls = function () { var t = this, e = this._points; if (!1 !== this._visible && 0 !== e.length) {
    var i = e.filter(function (i, n) { return 1 === e.length || !t._open || n !== e.length - 1; }).map(function (i, n) { var o = [rl_web_components_core_js_1.h("circle", { cx: i.x, cy: i.y, r: 8 / t._scale, index: 2 * n, class: "rl-map-control" })]; if (!t._open) {
        var r = Coordinate.midpoint(i, n === e.length - 1 ? e[0] : e[n + 1]);
        o.push(rl_web_components_core_js_1.h("circle", { cx: r.x, cy: r.y, r: 8 / t._scale, index: 2 * n + 1, class: "rl-map-midpoint" }));
    } return o; }), n = rl_web_components_core_js_1.h("path", { class: "rl-map-outline", d: pathFromCoordinateArray(e, this._open) });
    return rl_web_components_core_js_1.h("g", null, n, i);
} }, e; }(MapElement), MarkerIcon = function () { function t() { this._anchor = new Coordinate(0, 0), this._originalSize = { width: 1, height: 1 }, this._size = { width: 1, height: 1 }, this._scale = 1, this._url = ""; } return Object.defineProperty(t.prototype, "anchor", { get: function () { return this._anchor; }, set: function (t) { this._anchor = t; }, enumerable: !0, configurable: !0 }), Object.defineProperty(t.prototype, "originalSize", { get: function () { return this._originalSize; }, set: function (t) { this._originalSize = t; }, enumerable: !0, configurable: !0 }), Object.defineProperty(t.prototype, "size", { get: function () { return this._size; }, set: function (t) { this._size = t; }, enumerable: !0, configurable: !0 }), Object.defineProperty(t.prototype, "scale", { get: function () { return this._scale; }, set: function (t) { this._scale = t; }, enumerable: !0, configurable: !0 }), Object.defineProperty(t.prototype, "url", { get: function () { return this._url; }, set: function (t) { this._url = t; }, enumerable: !0, configurable: !0 }), t.prototype.render = function () { var t = "translate(" + this._anchor.toPathString() + ") scale(" + this._scale + ")"; return rl_web_components_core_js_1.h("image", { class: "rl-map-element__icon", height: this.size.height, transform: t, xlinkHref: this._url }); }, t; }();
exports.k = MapMarker;
exports.j = MapPolygon;
!function (t) { t.computer = "M 8 36 c -2 0 -4 -2 -4 -4 v -20 c 0 -2 2 -4 4 -4 h 32 c 2 0 4 2 4 4 v 20 c 0 2 -2 4 -4 4 h 8 v 4 h -48 v -4 z M 8 12 h 32 v 20 h -32 z"; }(MarkerSymbolPaths || (MarkerSymbolPaths = {}));
var MarkerSymbol = function () { function t() { this._anchor = new Coordinate(0, 0), this._path = "", this._pathName = "", this._rotation = 0, this._size = { width: 1, height: 1 }; } return Object.defineProperty(t.prototype, "anchor", { get: function () { return this._anchor; }, set: function (t) { this._anchor = t; }, enumerable: !0, configurable: !0 }), Object.defineProperty(t.prototype, "path", { get: function () { return this._path; }, set: function (t) { t in MarkerSymbolPaths ? (this._pathName = t, this._path = MarkerSymbolPaths[t]) : (this._pathName = "custom", this._path = t); }, enumerable: !0, configurable: !0 }), Object.defineProperty(t.prototype, "rotation", { get: function () { return this._rotation; }, set: function (t) { this._rotation = t % 360; }, enumerable: !0, configurable: !0 }), Object.defineProperty(t.prototype, "size", { get: function () { return this._size; }, set: function (t) { this._size = t; }, enumerable: !0, configurable: !0 }), t.prototype.render = function () { var t = this._size.width / 48, e = this._size.height / 48, i = "translate(" + this._anchor.toPathString() + ") rotate(" + this._rotation + ") scale(" + t + ", " + e + ")", n = { "rl-map-symbol": !0 }; return n["rl-map-symbol--" + this._pathName] = !0, rl_web_components_core_js_1.h("path", { class: n, transform: i, d: this._path }); }, t; }(), HYSTERESIS = 8, DEFAULT_MAX_SCALE = 3, DEFAULT_MIN_SCALE = 1, STATES = { NORMAL: 0, GESTURE_DOWN: 1, DRAGGING: 2, ZOOMING: 3, ADD_REGION_INIT: 10, ADD_REGION_FIRST: 11, ADD_REGION: 12, ADD_POINT: 20, DRAG_ELEMENT: 30 };
exports.h = HYSTERESIS;
exports.c = DEFAULT_MAX_SCALE;
exports.d = DEFAULT_MIN_SCALE;
exports.a = STATES;
function computeLimits(t, e, i) { return new DOMRect(Math.min(0, e.width - t.width * i), Math.min(0, e.height - t.height * i), Math.abs(t.width * i - e.width), Math.abs(t.height * i - e.height)); }
exports.i = computeLimits;
function getTargetId(t) { if ((t instanceof SVGImageElement || t instanceof SVGRectElement) && (t = t.parentElement), t instanceof SVGPathElement || t instanceof SVGGElement)
    return Number(t.id); }
exports.g = getTargetId;
function parseElements(t, e) { return void 0 === e && (e = 1), Object.values(t).map(function (t) { var i, n, o = decodeCoordinates(t.points, !0); return void 0 !== t.icon ? (i = new MarkerIcon).url = t.icon : void 0 !== t.symbol && t.symbol in MarkerSymbolPaths && ((i = new MarkerSymbol).path = t.symbol), o.points instanceof Coordinate ? ((n = new MapMarker).icon = i, n.position = o.points, n.available = t.available || !1) : (n = new MapPolygon).points = o.points, n.id = t.id, n.name = t.name, n.visible = t.enabled, n.scale = e, n.clickable = void 0 === t.clickable || t.clickable, n; }); }
exports.e = parseElements;
