export class RLTextLog {
    constructor() {
        this.strings = [];
    }
    /**
     * Add a new line to the log.
     * @param str A string to write to the log
     */
    log(str = '') {
        this.strings = [...this.strings, str];
    }
    hostData() {
        return {
            class: {
                'rl-text-log': true,
            }
        };
    }
    render() {
        return this.strings.map(s => h("div", null, s));
    }
    static get is() { return "rl-text-log"; }
    static get properties() { return {
        "log": {
            "method": true
        },
        "strings": {
            "state": true
        }
    }; }
    static get style() { return "/**style-placeholder:rl-text-log:**/"; }
}
