import { h } from '../rl-web-components.core.js';

class RLTextLog {
    constructor() {
        this.strings = [];
    }
    log(str = '') {
        this.strings = [...this.strings, str];
    }
    hostData() {
        return {
            class: {
                'rl-text-log': true,
            }
        };
    }
    render() {
        return this.strings.map(s => h("div", null, s));
    }
    static get is() { return "rl-text-log"; }
    static get properties() { return {
        "log": {
            "method": true
        },
        "strings": {
            "state": true
        }
    }; }
    static get style() { return ""; }
}

export { RLTextLog as RlTextLog };
